from locate2 import *

class Player:
    def __init__(self, sprite, x, y):
        self.sprite = sprite
        self.x = x
        self.y = y

    def move(self, screen, plus_x, plus_y):
        screen.locate(self.x, self.y, " ")
        if screen.get_cell(self.x + plus_x, self.y + plus_y) not in "#-":
            self.x += plus_x
            self.y += plus_y
            cell_on = screen.get_cell(self.x, self.y)
            if cell_on == "|":
                self.display(screen)
                return "victory"
            elif cell_on == "^":
                self.move(screen, -plus_x, -plus_y)
                return "ouch"
        self.display(screen)

    def display(self, screen):
        screen.locate(self.x, self.y, self.sprite)

##### START ROOM DRAW #####
floor = Screen()
floor.load("#" * 21 + ("#" + " " * 19 + "#") * 4 + "#" * 21)
floor.locate(21, 4, "|")
for i in range(3, 21):
    patern = (i - 3) % 4
    if patern == 0:
        floor.locate_v(i, 2, "^ ^^")
    elif patern == 1:
        floor.locate_v(i, 2, "^  ^")
    elif patern == 2:
        floor.locate_v(i, 2, "^^ ^")
    else:
        floor.locate_v(i, 2, "^  ^")
##### END ROOM DRAW #####

# Player creation
player = Player("@", 2, 3)
# Player "summon" on floor
player.display(floor)

def title_screen():
    titleScreen = Screen()
    titleScreen.locate(1, 1, "---USELESS DEMO---")
    titleScreen.locate(2, 3, "[1] Start game")
    titleScreen.locate(2, 4, "[2] Help")
    titleScreen.locate(2, 5, "[3] Exit")

    choice = str()
    while not (len(choice) == 1 and choice in "123"):
        choice = titleScreen.refresh()
    return choice

def game_help():
    help_screen = Screen()
    help_screen.locate(1, 1, "-------HELP-------")
    help_screen.locate(11, 3, "8 < up")
    help_screen.locate(3, 4, "left > 4 6 < right")
    help_screen.locate(11, 5, "2 < down")
    help_screen.locate(11, 5, "0 < quit")
    help_screen.refresh()

def congratz():
    congratz_screen = Screen(patern="*")
    congratz_screen.locate(2, 3, "YOU BEAT THE DEMO !")
    congratz_screen.refresh()

def u_louse():
    u_louse_screen = Screen(patern="~")
    u_louse_screen.locate(6, 3, "You lose...")
    u_louse_screen.locate(5, 4, "[EXE] to exit")
    u_louse_screen.refresh()


def game():
    choice = str()
    buffer = str()
    life = 3

    while choice != "0":
        result = None
        if choice == "8":
            result = player.move(floor, 0, -1)
        if choice == "2":
            result = player.move(floor, 0, 1)
        if choice == "4":
            result = player.move(floor, -1, 0)
        if choice == "6":
            result = player.move(floor, 1, 0)

        if result == "ouch":
            floor.locate(15, 6, "OUCH !")
            life -= 1
            if not life:
                return False
        elif result == "victory":
            return True
        else:
            floor.locate(15, 6, "#" * 6)

        choice = floor.refresh()
        if not choice:
            choice = buffer
        buffer = choice


def main():
    continuer = True
    while continuer:
        choice = title_screen()
        continuer = False
        if choice == "1":
            result = game()
            if result:
                congratz()
            elif result is not None:
                u_louse()
        elif choice == "2":
            game_help()
            continuer = True

main() # Program launch.
